# coding: utf-8
module BlsmVdCore
  class User < BlsmVdCore::BaseRecord
    self.table_name='users'
    has_many :clearing_items, class_name: "::BlsmVdCore::ClearingItem"
    has_many :applications, class_name: "::BlsmVdCore::Application"
    has_many :clearings, class_name: "::BlsmVdCore::Clearing"
    has_one :vd_user_info, class_name: "::BlsmVdCore::VdUserInfo"
    belongs_to :rc_user, class_name: "::BlsmVdCore::RcUser"
    belongs_to :sq_inviter, class_name: '::BlsmVdCore::User', foreign_key: 'sq_from', primary_key: 'sq_code'

    def create_vd_user_info
      unless self.vd_user_info
        return VdUserInfo.create({
                                     user_id: self.id
                                 })
      end
      self.vd_user_info
    end

    #是否是黑带微店主
    def is_vd_black?
      info = self.vd_user_info || self.create_vd_user_info
      info.is_black?
    end
  end
end