# coding: utf-8
module BlsmVdCore
  class VdFreePost < BlsmVdCore::BaseRecord
    self.table_name='vd_free_posts'
    belongs_to :user, class_name: "::BlsmVdCore::User"
    belongs_to :order, class_name: "::BlsmVdCore::Order"

    DEFAULT_EXPIRE_AT = '2017-01-20 15:30'

    before_validation :gen_expire_at

    def expired?
      return false unless self.expire_at
      return true if Time.now.strftime('%Y-%m-%d %H:%M:%S')> self.expire_at.strftime('%Y-%m-%d %H:%M:%S')
      false
    end

    private
    def gen_expire_at
      unless self.expire_at
        default_time = Setting.where(name: 'vd_free_post_default_expire').pluck(:value)[0]
        self.expire_at = default_time || VdFreePost::DEFAULT_EXPIRE_AT
      end
    end
  end
end
