# coding: utf-8
module BlsmVdCore
  class VdInfoSec < BlsmVdCore::BaseRecord
    self.table_name='vd_info_secs'
    validates_uniqueness_of :transaction_no

    #是否是危险操作，如此动作在信息安全库中可以查询到，
    #说明此操作为危险动作，默认返回危险信息
    #====Parameters
    # * +vd_transaction+ - 交易描述
    def self.dangerous?(vd_transaction)
      vd_info_sec = VdInfoSec.where(transaction_no: Digest::MD5.hexdigest(vd_transaction)).first
      if vd_info_sec
        BlsmVdCore::ERROR_CODES[4010][:vd_info_sec]=vd_info_sec
        return BlsmVdCore::ERROR_CODES[4010]
      end
      false
    end

    #录入安全信息
    # #====Parameters
    # * +vd_transaction+ - 交易描述
    def self.committed(vd_transaction)
      VdInfoSec.create({
                           transaction_no: Digest::MD5.hexdigest(vd_transaction),
                           description: vd_transaction
                       })
    end
  end
end