# coding: utf-8
module BlsmVdCore
  class VdInviteReward < BlsmVdCore::BaseRecord
    self.table_name='vd_invite_rewards'
    belongs_to :inviter, foreign_key: 'inviter_id', class_name: '::BlsmVdCore::User'
    belongs_to :invitee, foreign_key: 'invitee_id', class_name: '::BlsmVdCore::User'
    belongs_to :order, class_name: "::BlsmVdCore::Order"
    belongs_to :clearing_item, class_name: "::BlsmVdCore::ClearingItem"

    #week 格式：2017-0220-0226
    before_create :generate_week

    private

    #默认生成上一周的week开始日+结束日
    def generate_week
      unless self.week
        t = Time.now - 7.day
        self.week = "#{t.strftime('%Y')}-#{t.at_beginning_of_week.strftime("%m%d")}-#{t.at_end_of_week.strftime("%m%d")}"
      end
    end
  end
end
