# coding: utf-8
module BlsmVdCore
  class VdUserInfo < BlsmVdCore::BaseRecord
    self.table_name='vd_user_infos'
    validates_uniqueness_of :user_id
    belongs_to :user, class_name: '::BlsmVdCore::User'
    belongs_to :supervisor, class_name: '::BlsmVdCore::User'

    LEVELS = {
        1 => '普通店主',
        2 => '金牌店主',
        3 => '钻石店主'
    }

    #變化積分
    def change_score(changed_score)
      VdUserInfo.update_counters(self.id, score: changed_score)
    end

    #是否是黑带
    def is_black?
      self.vd_role == 'black'
    end

    #店主等级
    def level
      return 3 if self.distribute_sum.to_f>=5000
      return 2 if self.distribute_sum.to_f>=1500

      golden_pay = VdWxPay.where(user_id: self.user_id,
                                 return_code: 'SUCCESS',
                                 result_code: 'SUCCESS',
                                 vd_service_id: 1
      ).first
      return 2 if golden_pay
      1
    end

    #利润率，跟销售额有关系
    def profit_rate
      return 1 if level>=2
      #兼容老店主
      if self.created_at.to_s[0,10]<'2016-12-16'
        return 0.7 if self.distribute_sum.to_f<1500
        return 1
      end

      vd_wx_pay = VdWxPay.where(:user_id=>self.user_id,:return_code=>'SUCCESS',:result_code=>'SUCCESS',:vd_service_id=>2).first
      #是否是交98元开店的店主
      if vd_wx_pay.blank?
        return 0.5 if self.distribute_sum.to_f<1500
      else
        return 0.65 if self.distribute_sum.to_f<1500
      end
      1
    end
  end
end
